package de.intevation.flys.model;

import java.math.BigDecimal;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.GeneratedValue;
import javax.persistence.Column;
import javax.persistence.SequenceGenerator;
import javax.persistence.GenerationType;
import javax.persistence.OneToOne;
import javax.persistence.JoinColumn;

@Entity
@Table(name = "cross_section_points")
public class CrossSectionPoint
implements   Serializable
{
    private Integer          id;
    private CrossSectionLine crossSectionLine;
    private Integer          colPos;
    private BigDecimal       x;
    private BigDecimal       y;

    public CrossSectionPoint() {
    }

    public CrossSectionPoint(
        CrossSectionLine crossSectionLine,
        Integer          colPos,
        BigDecimal       x,
        BigDecimal       y
    ) {
        this.crossSectionLine = crossSectionLine;
        this.colPos           = colPos;
        this.x                = x;
        this.y                = y;
    }

    @Id
    @SequenceGenerator(
        name           = "SEQUENCE_CROSS_SECTION_POINTS_ID_SEQ",
        sequenceName   = "CROSS_SECTION_POINTS_ID_SEQ",
        allocationSize = 1)
    @GeneratedValue(
        strategy  = GenerationType.SEQUENCE,
        generator = "SEQUENCE_CROSS_SECTION_POINTS_ID_SEQ")
    @Column(name = "id")
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    @OneToOne
    @JoinColumn(name = "cross_section_line_id")
    public CrossSectionLine getCrossSectionLine() {
        return crossSectionLine;
    }

    public void setCrossSectionLine(CrossSectionLine crossSectionLine) {
        this.crossSectionLine = crossSectionLine;
    }

    @Column(name = "col_pos")
    public Integer getColPos() {
        return colPos;
    }

    public void setColPos(Integer colPos) {
        this.colPos = colPos;
    }

    @Column(name = "x")
    public BigDecimal getX() {
        return x;
    }

    public void setX(BigDecimal x) {
        this.x = x;
    }

    @Column(name = "y")
    public BigDecimal getY() {
        return y;
    }

    public void setY(BigDecimal y) {
        this.y = y;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
